<?php

class ControllerPaymentPagoEfectivo extends Controller {

    private $error = array();

    public function index() {

        $this->load->language('payment/pago_efectivo');

        $this->document->setTitle('PagoEfectivo Payment Method Configuration');

        $this->load->model('setting/setting');

        $token = 'token=' . $this->session->data['token'];

        $ds = DIRECTORY_SEPARATOR;

        $path_keys = DIR_CATALOG."pagoefectivo".$ds."keys";

        if (!file_exists($path_keys)) {
            if (!mkdir($path_keys, 0777, true)) {
                die('Failed to create folders...');
            }
        }
        
        if (($this->request->server['REQUEST_METHOD'] == 'POST')) {
                
            $pe_file_keys = $this->request->files;

            if($pe_file_keys['pago_efectivo_public_key']['error'] == 0){

                $pago_efectivo_ruta_public_key = $path_keys.$ds.$pe_file_keys['pago_efectivo_public_key']['name'];
                $pago_efectivo_name_public_key = $pe_file_keys['pago_efectivo_public_key']['name'];
                move_uploaded_file($pe_file_keys['pago_efectivo_public_key']['tmp_name'], $pago_efectivo_ruta_public_key);
                $this->request->post['pago_efectivo_public_key'] = $pago_efectivo_name_public_key;
                $this->data['pago_efectivo_public_key'] = $pago_efectivo_name_public_key;

            }else{
                $this->request->post['pago_efectivo_public_key'] = $this->config->get('pago_efectivo_public_key');
            }

            if($pe_file_keys['pago_efectivo_private_key']['error'] == 0){

                $pago_efectivo_ruta_private_key = $path_keys.$ds.$pe_file_keys['pago_efectivo_private_key']['name'];
                $pago_efectivo_name_private_key = $pe_file_keys['pago_efectivo_private_key']['name'];
                move_uploaded_file($pe_file_keys['pago_efectivo_private_key']['tmp_name'], $pago_efectivo_ruta_private_key);
                $this->request->post['pago_efectivo_private_key'] = $pago_efectivo_name_private_key;
                $this->data['pago_efectivo_private_key'] = $pago_efectivo_name_private_key;

            }else{
                $this->request->post['pago_efectivo_private_key'] = $this->config->get('pago_efectivo_private_key');
            }

            $this->model_setting_setting->editSetting('pago_efectivo', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->link('extension/payment', 'token='.$this->session->data['token'], 'SSL'));

        }

        $fields = array('name_portal', 'email_portal', 'merchant_id', 'ip_address', 'currency', 'title_desc_banc', 'title_desc_agent', 'content_question', 'url_question', 'integration_mode', 'pagoefectivo_url_server', 'connect_test', 'public_key', 'private_key', 'time_expired', 'time_expired_day', 'time_expired_hour', 'time_expired_minute', 'status', 'order_status_id');

        $labels = array('heading_title', 'text_home', 'text_payment', 'text_enabled', 'text_disabled', 'text_dolar', 'text_sol', 'text_iframe', 'text_redirect', 'text_name_portal', 'text_email_portal', 'text_merchant_id', 'text_ip_address', 'text_currency_type', 'text_title_desc_banc', 'text_title_desc_agent', 'text_content_question', 'text_url_question', 'text_integration_mode', 'text_pagoefectivo_url_server', 'text_connect_test', 'text_url_test', 'text_public_key', 'text_private_key', 'text_time_expired', 'entry_status', 'entry_order_status', 'button_save', 'button_cancel');

        foreach (array_merge($fields, $labels) as $value) {
            $this->data[$value] = $this->language->get($value);
        }

        foreach ($fields as $value) {
            $attribute = 'pago_efectivo_' . $value;
            if (isset($this->request->post[$attribute])) {
                $this->data[$attribute] = $this->request->post[$attribute];
            } else {
                $this->data[$attribute] = $this->config->get($attribute);
            }
        }

        $this->data['title_desc_banc_default'] = "Paga a través de tu banca por internet en BBVA, BCP, INTERBANK, SCOTIABANK y BANBIF. Debítalo de tu cuenta o cárgalo a tu tarjeta de crédito asociada.";
        $this->data['title_desc_agent_default'] = "Acércate a cualquier punto del BBVA, BCP, INTERBANK, SCOTIABANK y BANBIF. Agentes corresponsales KASNET, WESTERN UNION - Pago de Servicios y FULLCARGA.";
        $this->data['content_question_default'] = "¿Qué es pago efectivo?";
        $this->data['url_question_default'] = "https://cip.pagoefectivo.pe/CNT/QueEsPagoEfectivo.aspx";
        $this->data['url_server_pagoefectivo'] = "https://cip.pre.2b.pagoefectivo.pe/";
        $this->data['url_test'] = HTTP_CATALOG."index.php?route=test/pago_efectivo_test";

        $links_map = array('text_home' => 'common/home',
        'text_payment' => 'extension/payment',
        'heading_title' => 'payment/pago_efectivo');

        $this->data['breadcrumbs'] = array();
        foreach ($links_map as $key => $value) {
          array_push($this->data['breadcrumbs'], array('text' => $this->data[$key],
              'href' => $this->url->link($value, $token, 'SSL')));
        }

        $this->data['action'] = $this->url->link('payment/pago_efectivo', $token, 'SSL');

        $this->data['cancel'] = $this->url->link('extension/payment', $token, 'SSL');
        
        $this->load->model('localisation/order_status');

        $this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $this->template = 'payment/pago_efectivo.tpl';

        $this->children = array('common/header', 'common/footer');

        $this->response->setOutput($this->render());

    }

}